---
title: function declaration
slug: Web/JavaScript/Reference/Statements/function
tags:
  - Function
  - JavaScript
  - Language feature
  - Statement
---
<div>{{jsSidebar("Statements")}}</div>

<p>The <strong>function declaration</strong> (function statement) defines a function with the specified parameters.</p>

<p>You can also define functions using the {{jsxref("Function")}} constructor and a {{jsxref("Operators/function", "function expression", "", 1)}}.</p>

<div>{{EmbedInteractiveExample("pages/js/statement-function.html","shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">function <var>name</var>([<var>param</var>[, <var>param</var>,[..., <var>param</var>]]]) {
   [<var>statements</var>]
}
</pre>

<dl>
 <dt><code><var>name</var></code></dt>
 <dd>The function name.</dd>
</dl>

<dl>
 <dt><code><var>param</var></code> {{optional_inline}}</dt>
 <dd>The name of an argument to be passed to the function. Maximum number of arguments varies in different engines.</dd>
</dl>

<dl>
 <dt><code><var>statements</var></code> {{optional_inline}}</dt>
 <dd>The statements which comprise the body of the function.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>A function created with a function declaration is a <code>Function</code> object and has all the properties, methods and behavior of <code>Function</code> objects. See {{jsxref("Function")}} for detailed information on functions.</p>

<p>A function can also be created using an expression (see {{jsxref("Operators/function", "function expression", "", 1)}}).</p>

<p>By default, functions return <code>undefined</code>. To return any other value, the function must have a {{jsxref("Statements/return", "return")}} statement that specifies the value to return.</p>

<h3 id="Conditionally_created_functions">Conditionally created functions</h3>

<p>Functions can be conditionally declared, that is, a function statement can be nested within an <code>if</code> statement, however the results are inconsistent across implementations and therefore this pattern should not be used in production code. For conditional function creation, use function expressions instead.</p>

<pre class="brush: js notranslate">var hoisted = "foo" in this;
console.log(`'foo' name ${hoisted ? "is" : "is not"} hoisted. typeof foo is ${typeof foo}`);
if (false) {
  function foo(){ return 1; }
}

// In Chrome:
// 'foo' name is hoisted. typeof foo is undefined
//
// In Firefox:
// 'foo' name is hoisted. typeof foo is undefined
//
// In Edge:
// 'foo' name is not hoisted. typeof foo is undefined
//
// In Safari:
// 'foo' name is hoisted. typeof foo is function
</pre>

<p>The results are exactly the same for a condition that evaluates to true</p>

<pre class="brush: js notranslate">var hoisted = "foo" in this;
console.log(`'foo' name ${hoisted ? "is" : "is not"} hoisted. typeof foo is ${typeof foo}`);
if (true) {
  function foo(){ return 1; }
}

// In Chrome:
// 'foo' name is hoisted. typeof foo is undefined
//
// In Firefox:
// 'foo' name is hoisted. typeof foo is undefined
//
// In Edge:
// 'foo' name is not hoisted. typeof foo is undefined
//
// In Safari:
// 'foo' name is hoisted. typeof foo is function
</pre>

<h3 id="Function_declaration_hoisting">Function declaration hoisting</h3>

<p>Function declarations in JavaScript are hoisted to the top of the enclosing function or global scope. You can use the function before you declared it:</p>

<pre class="brush: js notranslate">hoisted(); // logs "foo"

function hoisted() {
  console.log('foo');
}
</pre>

<p>Note that {{jsxref("Operators/function", "function expressions", "", 1)}} are not hoisted:</p>

<pre class="brush: js notranslate">notHoisted(); // TypeError: notHoisted is not a function

var notHoisted = function() {
   console.log('bar');
};
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_function">Using function</h3>

<p>The following code declares a function that returns the total amount of sales, when given the number of units sold of products <code>a</code>, <code>b</code>, and <code>c</code>.</p>

<pre class="brush: js notranslate">function calc_sales(units_a, units_b, units_c) {
   return units_a * 79 + units_b * 129 + units_c * 699;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-function-definitions', 'Function definitions')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements.function")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Function")}}</li>
 <li>{{jsxref("Operators/function", "function expression", "", 1)}}</li>
 <li>{{jsxref("Statements/function*", "function* statement", "", 1)}}</li>
 <li>{{jsxref("Operators/function*", "function* expression", "", 1)}}</li>
 <li>{{jsxref("Functions/Arrow_functions", "Arrow functions", "", 1)}}</li>
 <li>{{jsxref("GeneratorFunction")}}</li>
 <li>{{jsxref("Statements/async_function", "async function", "", 1)}}</li>
 <li>{{jsxref("Operators/async_function", "async function expression", "", 1)}}</li>
</ul>
